C:每日一题:双指针法的使用

前言:

思虑再三,觉得如果有时间每日一题还是可以更新一下的。

题目难度:基础

解题方法:双指针法

一、题目

输入一个整数数组,

实现一个函数来调整该数组中数字的顺序使得

数组中所有的奇数位于数组的前半部分,所有偶数位于数组的后半部分。

二、题目分析

本题目标:

将给定的整数数组中的奇数和偶数分开,使得奇数在前半部分,偶数在后半部分,同时保持奇数和偶数各自的相对顺序不变。

算法选择:双指针法

选择双指针法是因为它只需要对数组遍历一次即可。时间复杂度较低。

设置两个指针 left 和 right 分别指向数组的头部和尾部。

循环选择:while循环

循环条件是 **left < right,**这是为了确保两个指针相遇前能够持续进行调整

指针移动的条件及逻辑(奇数在偶数左边)

当left指针指向的数是奇数时,说明当前数字所在位置正确,无需调整,直接移动到下一位(后一位)

当right指针指向的数时偶数时,说明当前数字所在位置正确,无需调整,直接移动到上一位(前一位)

数字交换及位置调整:

当left 指向偶数且right指向奇数时,说明这两个数字的位置需要交换。通过交换这两个数字,将奇数移动到数组的前半部分,偶数移动到数组的后半部分。

交换后,left 指针后移一位,right指针前移一位,继续进行下一轮的调整。

三、代码展示:

复制代码
#include <stdio.h>

void sort(int arr[], int sz)
{
    int left = 0;  // 指向数组头部的指针
    int right = sz - 1;  // 指向数组尾部的指针
    while (left < right)
    {
        if (arr[left] % 2 == 1)
        {
            left++;  // 如果 left 指向奇数,left 指针后移,因为奇数应在数组前半部分
        }
        else if (arr[right] % 2 == 0)
        {
            right--;  // 如果 right 指向偶数,right 指针前移,因为偶数应在数组后半部分
        }
        else
        {
            int tmp = arr[left];
            arr[left] = arr[right];
            arr[right] = tmp;
            left++;  // 交换后 left 指针后移
            right--;  // 交换后 right 指针前移
        }
    }
}

int main()
{
    int arr[10] = { 0 };
    int sz = sizeof(arr) / sizeof(arr[0]);
    for (int i = 0; i < sz; i++)
    {
        scanf("%d", &arr[i]);  // 输入数组元素
    }
    sort(arr, sz);  // 调用函数实现奇数在前、偶数在后的调换
    for (int i = 0; i < sz; i++)
    {
        printf("%d ", arr[i]);  // 输出调整后的数组
    }
    return 0;
}

结语:

今天这道题比较简单,我写这道题主要也就是想介绍一个双指针法的使用,还望理解!

后面有时间小编会更新一篇文章来详细介绍一下双指针法,敬请期待!

相关推荐
(Charon)1 分钟前
【C++面试】手写String类:同时实现拷贝构造与移动构造
c++·算法
迷途之人不知返20 分钟前
算法系列6:模拟
算法
旺仔仔仔29 分钟前
# 机器人项目实战(1):选相机、试深度,再到手眼标定
算法
CoderYanger40 分钟前
A.每日一题:1614. 括号的最大嵌套深度
java·程序人生·算法·leetcode·面试·学习方法
yuki蜜语43 分钟前
别只会调包跑模型!一文讲透大模型训练底层的“递推、递归、三明治”三重逻辑
算法
成旭先生1 小时前
银行卡识别 API:一张照片读出卡号、BIN 与发卡行
人工智能·算法·ocr·api接口·金融科技·银行卡识别·支付风控
陌上花开缓缓归以1 小时前
mebdlts3.4.1安全启动全流程
服务器·算法
Nebula_g1 小时前
JavaSE拓展:可变参数
java·开发语言·算法·安全·javase·可变参数
Logic1011 小时前
C语言/数据结构字符串题解:最短循环节——找出能重复构成原串的最短基础子串
c语言·数据结构·字符串·枚举·时间复杂度·算法题·kmp优化
129Lab2 小时前
BMS 核心算法:SOC 估算从安时积分到 LSTM-UKF 串级融合的 30 年演进(附 Python 实现)
python·算法·lstm·python3.11·bms·soc估算